<?php

namespace Drupal\qtools_common\Twig;

use Drupal\Core\Url;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

/**
 * Provides Convenient way to create refs to theme resources.
 */
class QSrcExtension extends AbstractExtension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'qsrc';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new TwigFunction('qsrc', [$this, 'qSrcFunction'], ['is_safe' => ['html']]),
    ];
  }

  /**
   * Builds url from internal path.
   *
   * @return string
   *   Complete url.
   */
  public function qSrcFunction($theme, $text) {
    $uri = 'internal:/' . drupal_get_path('theme', $theme);
    $path = Url::fromUri($uri)->toString();
    $output = str_replace('@@', $path, $text);
    return $output;
  }

}
