<?php

namespace Drupal\qtools_common\Twig;

use Drupal\Core\Url;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

/**
 * Provides way to build links from path.
 */
class QUrlExtension extends AbstractExtension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'qurl';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new TwigFunction('qurl', [$this, 'qUrlFunction'], ['is_safe' => ['html']]),
    ];
  }

  /**
   * Builds url from internal path.
   *
   * @return string
   *   Complete url.
   */
  public function qUrlFunction($uri) {
    $output = Url::fromUri($uri)->toString();
    return $output;
  }

}
