<?php

namespace Drupal\qtools_common\Utility;

use Drupal\Core\Cache\CacheableDependencyInterface;

/**
 * Describe interface for configurable (service or class).
 */
interface QToolsConfigurableInterface extends CacheableDependencyInterface {

  /**
   * Returns Keyed array of configuration with default values.
   */
  public function getConfigTraitDefaults(): array;

  /**
   * Returns configuration name/prefix.
   */
  public function getConfigTraitBundle(): string;

  /**
   * Gets config value.
   *
   * @throws \Exception
   */
  public function config(string $key): mixed;

}
