<?php

namespace Drupal\qtools_common\Utility;

use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Provides redirect response that will call drupals terminate sequence.
 */
class TerminatedRedirectResponse extends RedirectResponse {

  /**
   * Flags if this response already terminated.
   *
   * @var bool
   */
  protected $terminated = FALSE;

  /**
   * Override send method to trace this forced redirect.
   *
   * @see \Symfony\Component\HttpKernel\HttpKernel
   */
  public function send() {
    if (!$this->terminated) {
      $this->terminated = TRUE;

      /** @var \Symfony\Component\HttpKernel\HttpKernel $kernel */
      $kernel = \Drupal::service('http_kernel');
      $request = \Drupal::request();
      $kernel->terminate($request, $this);

      // Send response.
      return parent::send();
    }
    else {
      return parent::send();
    }
  }

}
